[bitcoin/bitcoin] RFC: C++14 Requirement (#13356)

Opening an issue after some recent [IRC discussion](https://botbot.me/freenode/bitcoin-core-dev/2018-05-30/?msg=100617206&page=4) about moving to requiring C++14.

#### GCC:
C++14 is the default mode in [GCC 6.1](https://gcc.gnu.org/projects/cxx-status.html#cxx14).
«The default mode for C++ is now -std=gnu++14 instead of -std=gnu++98.».

#### Clang:
C++14 is available from Clang [3.4+](https://clang.llvm.org/cxx_status.html).

More to come:

Добавить комментарий